##############################################################################
#
# Enfold Stage Deployment - Remote Deployment of Staged Content
# Copyright (C) 2005 Enfold Systems
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
##############################################################################
"""
$Id: utils.py 3534 2005-12-02 21:16:39Z arunyan $
"""

from ZConfig.datatypes import SocketAddress
from Products.CMFCore.utils import getToolByName
from Products.StageDeployment.config import *
from Products.Archetypes.utils import shasattr

_marker = object()

def _getTargetAddress(context):
    # Let it acquire
    pname = DEPLOYMENT_TARGET
    address = getattr(context, pname, _marker)
    if address is not _marker:
        return address
    # Default to portal-wide setting
    pprops = getToolByName(context, 'portal_properties', _marker)
    if pprops is _marker:
        raise ValueError, "Could not find 'portal_properties' tool"
    dprops = getToolByName(pprops, 'stage_deployment', _marker)
    if dprops is _marker:
        raise ValueError, ("Could not find StageDeployment "
                           "settings. Make sure you installed and "
                           "configured the StageDeployment product "
                           "correctly.")
    return dprops.getProperty(pname)

def getTargetAddress(context, default=DEFAULT_TARGET):
    return _getTargetAddress(context) or default

def getSocketAddress(context, default=DEFAULT_TARGET):
    addr = getTargetAddress(context, default=default)
    return makeSocketAddress(addr)

def makeSocketAddress(addr):
    return SocketAddress(addr).address

def getDeploymentsInfo(stage):
    info = {}
    if not shasattr(stage, '_deployment_info'):
        return info
    d_info = getattr(stage, '_deployment_info')
    for key, t_info in d_info.items():
        info[key] = t_info.last()
    return info

def entransitOnPath():
    try:
        import entransit.client
        return True
    except ImportError:
        return False
    
